"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.circuitBreaker = void 0;
var _lambda = require("../sinks/lambda");
var _utils = require("../utils");
// typically used for egress gateways
// attached to a CloudWatch alarm
// https://docs.aws.amazon.com/AmazonCloudWatch/latest/monitoring/AlarmThatSendsEmail.html#alarms-and-actions

const circuitBreaker = opt => s => s // eslint-disable-line import/prefer-default-export
.map(toUpdateRequest(opt)).through((0, _lambda.updateEventSourceMapping)(opt));
exports.circuitBreaker = circuitBreaker;
const toUpdateRequest = opt => (0, _utils.faulty)(uow => ({
  ...uow,
  updateRequest: {
    UUID: process.env.ESM_ID,
    // Ref: TriggerEventSourceMappingDynamodbEntitiesTable
    Enabled: uow.event.alarmData.state.value !== 'ALARM',
    BatchSize: uow.event.alarmData.state.value === 'INSUFFICIENT_DATA' ? 1 : process.env.BATCH_SIZE || 100
  }
}));