"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sendMessages = void 0;
var _utils = require("../utils");
var _dynamodb = require("../queries/dynamodb");
var _sns = require("../sinks/sns");
var _sqs = require("../sinks/sqs");
var _filters = require("../filters");
const sendMessages = rule => s => s // eslint-disable-line import/prefer-default-export
.filter(_filters.outLatched).filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).through((0, _utils.compact)(rule)).map(toQueryRequest(rule)).through((0, _dynamodb.queryAllDynamoDB)(rule)).map(toGetRequest(rule)).through((0, _dynamodb.batchGetDynamoDB)(rule)).map(toMessage(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through(rule.sns || rule.topicArn ? (0, _sns.publishToSns)(rule) : (0, _sqs.sendToSqs)(rule)).tap(_utils.printEndPipeline);
exports.sendMessages = sendMessages;
const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));
const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));
const toQueryRequest = rule => (0, _utils.faulty)(uow => ({
  ...uow,
  queryRequest: rule.toQueryRequest ? /* istanbul ignore next */rule.toQueryRequest(uow, rule) : undefined
}));
const toGetRequest = rule => (0, _utils.faulty)(uow => ({
  ...uow,
  batchGetRequest: rule.toGetRequest ? /* istanbul ignore next */rule.toGetRequest(uow, rule) : undefined
}));
const toMessage = rule => (0, _utils.faultyAsyncStream)(async uow => ({
  ...uow,
  message: await (0, _utils.faultify)(rule.toMessage)(uow, rule)
}));