"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.update = void 0;
var _utils = require("../utils");
var _dynamodb = require("../queries/dynamodb");
var _dynamodb2 = require("../sinks/dynamodb");
var _filters = require("../filters");
var _correlate = require("./correlate");
const update = rule => s => s // eslint-disable-line import/prefer-default-export
// reacting to collected events vs change events
.map(uow => uow.record.eventName === 'INSERT' && uow.record.dynamodb.Keys.sk.S === 'EVENT' ? /* istanbul ignore next */(0, _correlate.normalize)(uow) : uow).filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).through((0, _utils.compact)(rule)).map(toQuery(rule)).through((0, _dynamodb.queryAllDynamoDB)(rule)).through((0, _utils.splitObject)({
  splitTargetField: rule.queryResponseField || 'queryResponse',
  ...rule
})).map(toGetRequest(rule)).through((0, _dynamodb.batchGetDynamoDB)(rule)).map(toUpdateRequest(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through((0, _dynamodb2.updateDynamoDB)(rule)).tap(_utils.printEndPipeline);
exports.update = update;
const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));
const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));
const toQuery = rule => (0, _utils.faulty)(uow => ({
  ...uow,
  queryRequest: rule.toQueryRequest ? rule.toQueryRequest(uow, rule) : undefined
}));
const toGetRequest = rule => (0, _utils.faulty)(uow => ({
  ...uow,
  batchGetRequest: rule.toGetRequest ? rule.toGetRequest(uow, rule) : undefined
}));
const toUpdateRequest = rule => (0, _utils.faultyAsyncStream)(uow => Promise.resolve(rule.toUpdateRequest(uow, rule)).then(updateRequest => ({
  ...uow,
  updateRequest
})));