"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.redeemClaimcheck = void 0;
var _compression = require("../utils/compression");
var _faults = require("../utils/faults");
var _s = require("./s3");
// claim-check pattern support
// https://www.enterpriseintegrationpatterns.com/patterns/messaging/StoreInLibrary.html

const redeemClaimcheck = (opt = {}) => s => s // eslint-disable-line import/prefer-default-export
.map((0, _faults.faulty)(uow => ({
  ...uow,
  getClaimCheckRequest: uow.event.s3 ? {
    Bucket: uow.event.s3.bucket,
    Key: uow.event.s3.key
  } : undefined
}))).through((0, _s.getObjectFromS3)({
  id: 'handler:claimcheck',
  getRequestField: 'getClaimCheckRequest',
  getResponseField: 'getClaimCheckResponse',
  additionalClientOpts: {
    followRegionRedirects: true
  }
})).map((0, _faults.faulty)(uow => clear({
  ...uow,
  event: uow.getClaimCheckResponse ? JSON.parse(Buffer.from(uow.getClaimCheckResponse.Body), _compression.decompress) : uow.event
})));
exports.redeemClaimcheck = redeemClaimcheck;
const clear = uow => {
  if (uow.getClaimCheckRequest === undefined) {
    // backwards compatibility for test cases
    delete uow.getClaimCheckRequest;
    delete uow.getClaimCheckResponse;
  }
  return uow;
};