"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.listEventSourceMappings = void 0;
var _highland = _interopRequireDefault(require("highland"));
var _lambda = _interopRequireDefault(require("../connectors/lambda"));
var _faults = require("../utils/faults");
var _print = require("../utils/print");
const listEventSourceMappings = ({
  // eslint-disable-line import/prefer-default-export
  debug = (0, _print.debug)('lambda')
} = {}) => {
  const connector = new _lambda.default({
    debug
  });
  const list = uow => {
    const {
      region,
      ...params
    } = uow.listRequest;
    connector.client.config.region = region || process.env.AWS_REGION;
    const p = connector.listEventSourceMappings(params).then(listResponse => ({
      ...uow,
      listResponse
    })).catch((0, _faults.rejectWithFault)(uow));
    return (0, _highland.default)(p); // wrap promise in a stream
  };
  return s => s.flatMap(list);
};
exports.listEventSourceMappings = listEventSourceMappings;