"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.zip = exports.unzip = exports.decompress = exports.compress = exports.COMPRESSION_PREFIX = void 0;
var _zlib = _interopRequireDefault(require("zlib"));
var _objectSizeof = _interopRequireDefault(require("object-sizeof"));
const COMPRESSION_PREFIX = exports.COMPRESSION_PREFIX = 'COMPRESSED';
const zip = str => _zlib.default.gzipSync(Buffer.from(str)).toString('base64');
exports.zip = zip;
const unzip = str => _zlib.default.gunzipSync(Buffer.from(str, 'base64')).toString();
exports.unzip = unzip;
const isArrayElement = key => Number.isInteger(Number.parseInt(key)); // eslint-disable-line radix

// JSON.stringify replacer
const compress = (opt = {
  compressionThreshold: 1024 * 10,
  compressionIgnore: []
}) => (key, value) => key /* no key is the top */ && !opt.compressionIgnore?.includes(key) && !isArrayElement(key)
// avoid compound compression
&& !(typeof value === 'string' && value.startsWith(COMPRESSION_PREFIX)) && (0, _objectSizeof.default)(value) > opt.compressionThreshold ? `${COMPRESSION_PREFIX}${zip(JSON.stringify(value))}` : value;

// JSON.parse reviver
exports.compress = compress;
const decompress = (key, value) => {
  if (typeof value === 'string' && value.startsWith(COMPRESSION_PREFIX)) {
    const dv = JSON.parse(unzip(value.substring(COMPRESSION_PREFIX.length)));
    // handle compound compression
    return decompress(key, dv);
  } else {
    return value;
  }
};
exports.decompress = decompress;