"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toPromise = exports.mw = void 0;
var _highland = _interopRequireDefault(require("highland"));
var _bluebird = _interopRequireDefault(require("bluebird"));
var _opt = require("./opt");
const mw = (handle, opt) => {
  const stack = [];
  const run = (event, context) => {
    const mwStack = [...stack, (n, o, e, c) => handle(e, c, o)]; // Do the real work last
    const runner = index => _bluebird.default.resolve(mwStack[index](() => runner(index + 1), opt, event, context));
    return _bluebird.default.resolve(runner(0));
  };
  run.use = middleware => {
    stack.push(...(Array.isArray(middleware) ? middleware : [middleware]));
    return run;
  };
  return run;
};
exports.mw = mw;
const toPromise = s => {
  const opt = (0, _opt.options)();
  if (opt.metrics) {
    return opt.metrics.toPromise(opt, s);
  } else {
    return new _bluebird.default((resolve, reject) => {
      s.consume((err, x, push, next) => {
        if (err) {
          reject(err);
        } else if (x === _highland.default.nil) {
          resolve('Success');
        } else {
          next();
        }
      }).resume();
    });
  }
};
exports.toPromise = toPromise;