"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.normalizeLogMsg = exports.defaultDebugLogger = void 0;
var _debug = require("debug");
var _util = require("util");
/* eslint-disable import/prefer-default-export */

const defaultDebugLogger = debug => {
  const dbg = debug || /* istanbul ignore next */(0, _debug.debug)('debug');
  const log = (...content) => dbg(...content.map(normalizeLogMsg));
  return {
    debug: () => {},
    info: log,
    warn: log,
    error: log
  };
};
exports.defaultDebugLogger = defaultDebugLogger;
const normalizeLogMsg = msg => (typeof msg === 'string' ? msg : (0, _util.inspect)(msg, {
  depth: 3
})).replace(/\n/g, '\r');
exports.normalizeLogMsg = normalizeLogMsg;