"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.options = exports.defaultOptions = void 0;
var _eventbridge = require("../sinks/eventbridge");
var _print = require("./print");
var _retry = require("./retry");
let opt = {};
const options = o => {
  if (o) opt = o;
  return opt;
};
exports.options = options;
const defaultOptions = exports.defaultOptions = {
  debug: (0, _print.debug)('handler'),
  busName: process.env.BUS_NAME,
  publish: _eventbridge.publishToEventBridge,
  maxRequestSize: Number(process.env.MAX_REQ_SIZE) || 1024 * 256,
  // 262,144
  compressionThreshold: Number(process.env.COMPRESSION_THRESHOLD) || 1024 * 10,
  // encryption
  eemField: 'eem',
  masterKeyAlias: process.env.MASTER_KEY_ALIAS,
  regions: process.env.KMS_REGIONS && process.env.KMS_REGIONS.split(','),
  AES: process.env.AES !== 'false',
  // lambda retry
  // can disable in index file by setting to undefined
  retryable: _retry.retryable
};