"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ttlRule = exports.ttl = exports.now = void 0;
var _isFunction = _interopRequireDefault(require("lodash/isFunction"));
const now = () => Date.now();
exports.now = now;
const ttl = (start, days) => Math.floor(start / 1000) + 60 * 60 * 24 * days;
exports.ttl = ttl;
const ttlRule = (rule, uow) => {
  if ((0, _isFunction.default)(rule.ttl)) {
    return rule.ttl(rule, uow);
  } else {
    return ttl(uow.event.timestamp, rule.ttl || rule.defaultTtl || process.env.TTL || 33);
  }
};
exports.ttlRule = ttlRule;